/*
 * CLOTH - Command Line Options Templates Header
 * (c) 2002-2004 Rob Hague
 *
 * A demonstration of CLOTH usage
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */


#include <cloth.hh>
#include <iostream>
#include <string>

// Declare some global Opt variables, and a Flag
cloth::Opt<int> i('i',"int","An integer",1);
cloth::Opt<int> d('d',"defint","An integer with the default default value");
cloth::Opt<string> s('s',0,"A string, which doesn't have a long name",
                    "A String");
cloth::Flag b('b',"bool","A boolean flag");

// Declare a Help option in the same way as any other Flag
cloth::Help helparg('h',"help");

int main(int argc, char **argv)
{
  // Call the parser (safe in the knowledge that all global variables will
  // have been initialized by this point)
  cloth::Parser::parse(argc,argv);

  // The options now hold the appropriate value; use them as if they were
  // consts of the appropriate type
  cout << "The value of i: " << i << "\n";
  cout << "The value of d: " << d << "\n";
  cout << "The value of s: " << (string)s << "\n";
  cout << "The value of b: " << b << "\n";
}
